
function isHex(h) {
	var isOk  = /(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(h);
	return isOk;
}

Array.prototype.move = function (old_index, new_index) {
    if (new_index >= this.length) {
        var k = new_index - this.length;
        while ((k--) + 1) {
            this.push(undefined);
        }
    }
    this.splice(new_index, 0, this.splice(old_index, 1)[0]);
    return this; // for testing purposes
};

/* Rendering Funcions */

// This function kicks off the generation of the necessary HTML to display the Councils Filters
function RenderCoucilsFilter(fn, filterName,globalVarURL) {
	GetCouncilsWithTopics(function(data) {
	    var councils = [];

	    $.each(data, function() {
	    	var council = 	{
	    						ID: this.ID,
					    		Title: this.Title,
					    		Colour: this.Colour_x0020_Coding,
					    		Acronym: this.Acronym,
								Topics: []
							};
			$.each(this.Topic.results, function(index, value) {
	    		var topic = {
	    			ID: this.ID,
	    			Title: this.Title
	    		}
	    		council.Topics.push(topic);
	    	});
	    	councils.push(council);
	    });

	    fn(councils, filterName);
	},globalVarURL);
}

// This function kicks off the generation of the necessary HTML to display the Meeting Types Filters
function RenderMeetingTypesFilter(fn, filterName,globalVarURL) {
	GetMeetingTypes(function(data) {
	    var meetingTypes = [];

	    $.each(data, function() {
	    	meetingTypes.push({
	    						ID: this.ID,
					    		Title: this.Title
							});
	    });

	    fn(meetingTypes, filterName);
	},globalVarURL);
}

// This function kicks off the generation of the necessary HTML to display the Meeting Locations Filters
function RenderMeetingLocationsFilter(fn, filterName){
	GetCultureMeetingLocations(function(data) {
	    var meetingLocations = [];

	    $.each(data, function() {
	    	meetingLocations.push({
	    						ID: this.ID,
					    		Title: this.Title
							});
	    });

	    fn(meetingLocations, filterName);
	});
}

// This function kicks off the generation of the necessary HTML to display the Cultural Area Filters
function RenderCulturalAreasFilter(fn, filterName) {
	GetCulturalAreas(function(data) {
	    var culturalAreas = [];

	    $.each(data, function() {
	    	culturalAreas.push({
	    						ID: this.ID,
					    		Title: this.Title,
					    		Colour: this.Colour_x0020_Coding,
					    		Acronym: this.Acronym
							});
	    });

	    fn(culturalAreas, filterName);
	});
}

function RenderFilters(filterItems, filterName) {
    debugger;
	var filterSection = $('div.filter-section.' + filterName + '-section');
    var headList ='';
    //code that create a header for meeting type or for council configuration
    if(filterName == 'meeting-type'){
        headList = '<div class="HeaderItemListFilt"></div><div class="HeaderListFilt" align="center"><p class="p thick thick4">Meeting Type</p></div>';   
    }
    else if (filterName == 'council'){
        headList = '<div class="HeaderItemListFilt"></div><div class="HeaderListFilt" align="center"><p class="p thick thick4">Council Configuration</p></div>';
    }
    
    filterSection.append(headList);
		
	filterSection.append("<div class='filter-item filter-all " + filterName + "-item' id='all-" + filterName + "'><div class='filter-checkbox' style='border-color: #143055;margin-top: -5px;'></div><div class='filter-title thick4'>All</div></div></div><hr class='filt filt3'>");
	
	$.each(filterItems, function() {
		filterSection.append(RenderFilter(filterName, this));
		var currentFilter = '#' + filterName + '-' + this.ID;
		$(currentFilter).on('click', function(){
			FilterBy(this.id);
		});
	});
	
	var selectAll = filterSection.find('.filter-item.filter-all');
	
	selectAll.on('click', function() {
		FilterByAll(this.id);
	});
	
	FilterByAll(selectAll.attr('id'));
    
    filterSection.append("<br>");
}

// This function generates the necessary HTML to display a filter
function RenderFilter(filterName, filterItem) {
	var strHtml = "	<div class='filter-item " + filterName + "-item' id='" + filterName + "-" + filterItem.ID + "'>";
	if(filterItem.Colour != null && isHex(filterItem.Colour)){
		strHtml += 		"<div class='filter-checkbox' style='border-color: #143055; margin-top:-5px;'></div>";
	} else {
		strHtml += 		"<div class='filter-checkbox' style='border-color: #143055; margin-top:-5px;'></div>";
	}
	strHtml += 			"<div class='filter-title thick4'>" + filterItem.Title + "</div>";
	strHtml += 			"<div class='filter-attributes'>";
	strHtml += 				"<div id='" + filterName + "-id'>" + filterItem.ID + "</div>";
	if(filterItem.Colour != null && isHex(filterItem.Colour)) {
		strHtml += 			"<div id='" + filterName + "-colour'>" + filterItem.Colour + "</div>";
	}
	if(filterItem.Acronym != null) {
		strHtml += 				"<div id='" + filterName + "-acronym'>" + filterItem.Acronym + "</div>";
	}
	strHtml += 			"</div>";
	if(filterItem.Topics != null) {
		strHtml += 		"<div class='topics'>";
		$.each(filterItem.Topics, function() {
			strHtml += 		"<div class='topic-item'>";
			strHtml += 			"<div id='topic-title'>" + this.Title + "</div>";
			strHtml += 			"<div id='topic-id'>" + this.ID + "</div>";
			strHtml += 		"</div>";
		});
		strHtml += 		"</div>";
	}
	strHtml += 		"</div><hr class='filt filt3'>";
	return strHtml;
}
/*
// This function is the onClick event handler for Council Filters
function FilterBy(filterItemId, selected) {
	var filterItem = $('#' + filterItemId);
	var checkBox = filterItem.children('.filter-checkbox');
	var colour = filterItem.find(".filter-attributes [id$='-colour']").html();

	if(selected == null) {
		checkBox.toggleClass('selected');
		filterItem.toggleClass('selected');

		var selectAll = filterItem.siblings('.filter-all');
		
		var allFiltersOfType = selectAll.siblings('.filter-item');
		var ofWhichAreSelected = allFiltersOfType.filter('.selected');
		
		if(allFiltersOfType.length > ofWhichAreSelected.length) {
			selectAll.removeClass('selected');
			selectAll.children('.filter-checkbox').removeClass('selected');
		} else if (allFiltersOfType.length == ofWhichAreSelected.length) {
			FilterByAll(selectAll.attr('id'));
		}
	} else {
		if(selected) {
			checkBox.addClass('selected');
			filterItem.addClass('selected');
		} else {
			checkBox.removeClass('selected');
			filterItem.removeClass('selected');
		}
	}
	
	// Apply checkbox colour if ticked
	if(checkBox.hasClass('selected')) {
		checkBox.css('background-color', '#FAAF40');
	} else {
		checkBox.css('background-color', '');
	}
}*/

// This function is the onClick event handler for Council Filters
function FilterBy(filterItemId, selected) {
                var filterItem = $('#' + filterItemId);
                var checkBox = filterItem.children('.filter-checkbox');
                var colour = filterItem.find(".filter-attributes [id$='-colour']").html();
                var selectAll = filterItem.siblings('.filter-all[id^="all-"]');

                if(selected == null) {
                                checkBox.toggleClass('selected');
                                filterItem.toggleClass('selected');

                                var allFiltersOfType;
                                                                                                
                                if(selectAll.length <= 0) {
                                                selectAll = filterItem.parents('.filter-item').first();
                                                allFiltersOfType = selectAll.find('.filter-item');
                                } else {
                                                allFiltersOfType = selectAll.siblings('.filter-item');
                                }                              
                               
                                var ofWhichAreSelected = allFiltersOfType.filter('.selected');
                                
                                if(allFiltersOfType.length > ofWhichAreSelected.length) {
                                                selectAll.removeClass('selected');
                                                selectAll.children('.filter-checkbox').removeClass('selected');
                                                var parentSelectAll = selectAll.siblings('.filter-item.filter-all[id^="all-"]').first();
                                                if(parentSelectAll.length > 0) {
                                                                parentSelectAll.removeClass('selected');
                                                                parentSelectAll.children('.filter-checkbox').removeClass('selected');
                                                }
                                } else if (allFiltersOfType.length == ofWhichAreSelected.length) {
                                                FilterByAll(selectAll.attr('id'));
                                }
                } else {
                                if(selected) {
                                                checkBox.addClass('selected');
                                                filterItem.addClass('selected');
                                } else {
                                                checkBox.removeClass('selected');
                                                filterItem.removeClass('selected');
                                }
                }
                
                if(filterItem.closest('.filter-section').find('.filter-item.selected').length == 0) {
                                var parentSelectAll = selectAll.siblings('.filter-item.filter-all[id^="all-"]').first();
                                if(parentSelectAll.length > 0) {
                                                parentSelectAll.addClass('selected');
                                                parentSelectAll.children('.filter-checkbox').addClass('selected');
                                } else {
                                                selectAll.addClass('selected');
                                                selectAll.children('.filter-checkbox').addClass('selected');
                                }
                }
                
                // Apply checkbox colour if ticked
                if(checkBox.hasClass('selected')) {
                                checkBox.css('background-color', colour);
                } else {
                                checkBox.css('background-color', '');
                }
}


// This function is the onClick event handler for the All Councils Filter
function FilterByAll(filterItemId) {

	var selectAll = $('.filter-item.filter-all#' + filterItemId);
	selectAll.addClass('selected');
	selectAll.children('.filter-checkbox').addClass('selected');

	var filterItems =  selectAll.siblings('.filter-item');
	
	$.each(filterItems, function() {
		FilterBy(this.id, false);
	});
}

// This function gives the Filter Tabs (Political and Culture) their onClick behaviour.
function BindFilterTabs() {
	var filterTabs = $('div.filter-tabs').children();
	
	$.each(filterTabs, function() {
		var tabContent = $('.filter-tab-content#' + this.id + '-content');
		
		if(tabContent.length > 0) {
			$(this).on('click', function() {
				filterTabs.removeClass('selected');
				$(this).addClass('selected');
				
				$('.filter-tab-content').hide();
				tabContent.show();
				
				if(this.id == 'political-tab') {
					RenderPoliticalEvents(PopulateEventsContainer, false);
					FilterByAll('all-meeting-type');
					FilterByAll('all-council');
				} else {
					RenderCulturalEvents(PopulateEventsContainer);
					FilterByAll('all-meeting-location');
					FilterByAll('all-cultural-area');
				}
			});
		}
	});
}

function GetFilters(filterName) {
	var result = [];
	
	var filters = $('.filter-item.' + filterName + '-item');
	var selectAllFilter = filters.filter('.filter-all');
	
	// If "All Filters" is checked, get the Filter Item ID for all filters
	if(selectAllFilter.hasClass('selected')) {
		selectAllFilter.siblings('.filter-item').children('.filter-attributes').children("[id$='-id']").each(function() { 
			result.push($(this).html()); 
		});
	// Else only get the Filter Item ID for the filters with the "selected" class
	} else {
		var selectedFilters = selectAllFilter.siblings('.filter-item').filter('.selected');
		selectedFilters.children('.filter-attributes').children("[id$='-id']").each(function() { 
			result.push($(this).html()); 
		});
	}

	return result;
}

function MatchFilter(eventItem, filterItems, criteria) {
	var isMatch = false;
	
	$.each(filterItems, function() {
		if($.inArray($(this).html(), criteria) >= 0) {
			isMatch = true;
			return;
		}
	});
	
	return isMatch;
}

// This function applies the selected filters
function ApplyFilters() {

    debugger;
    
    var counterShow = 0; //var that count the number of record matched
    
    $("#NoFound").remove();
    
    var meetingTypeToFilterWith = GetFilters('meeting-type');
    var councilsToFilterWith = GetFilters('council');

    var eventItems = $('div.events-container .event-item');
    eventItems.hide();

    $.each(eventItems, function() {
        var matchesFilters = [false, false];	

        var relatedCouncils = $(this).find('.area-tag #council-id');
        var meetingType = $(this).find('#meeting-type-id');

        if(MatchFilter(this, relatedCouncils, councilsToFilterWith) && MatchFilter(this, meetingType, meetingTypeToFilterWith)) {
            $(this).show();
            counterShow++;
        }
    });
	
    if(counterShow == 0){
        //$("#Event_placeholder").find("#oldH").css('display','none');
        ObliterateOldEvent();
        $("#Event_placeholder").append("<div id='NoFound' align='center'><p class='p thick bolder'>No matches found</p></div>");
    }
    else
    {
       $(".blackback.oldEvent").css("display","block"); 
    }
    
	PageEvents(true);
}

$(document).ready(function() {
	
	BindFilterTabs();
});

/* ****************************************** */