/* OData Functions */

// This function is our own implementation of the jQuery getJson function
function GetJson(restUrl, relativePath) {
	if(relativePath == null || relativePath == undefined){
		relativePath = '';
	}

    return $.ajax({
        type: 'GET',
        url: relativePath + restUrl,
        beforeSend: function()
        {
            $("#Event_placeholder").append('<div align="center"><img src="images/ajaxloader.gif" class="loader" /></div>');
        },
        error : function (richiesta,stato,errori) {
            if(!firstAcquired){
                ServerError(); 
            }
            else{
                firstAcquired = false;
            }   
        },
        //data: { get_param: 'value' }, 
        dataType: 'json',
        headers: {
            Accept: "application/json;odata=verbose"
        }
    });
}

// This function gets the results from the JSON object
function GetODataResult(data) {
    return data.d.results;
}

// This function is responsible for connecting to the endpoint and getting the necessary REST/OData query
function GetODataCommand(commandName, fn, relativePath) {
    GetJson("/_api/lists/GetbyTitle('AppConfigurations')/items?$select=Value&$filter=Title%20eq%20'" + commandName + "'",relativePath).success(function(data) {
        
        $('.loader').remove();
        
        var results = GetODataResult(data);

        if (results.length == 1) {
            fn(relativePath + results[0].Value);
        } else if (results.length > 1) {
            console.error("Multiple commands where found with the same name.");
        } else {
            console.error("Could not find the specified command.");
        }
    });
}

// The name of this function is an exact replica of the name of a list item in the AppConfiguration list.
// Calling this function will result in querying the AppConfiguration list for the REST/OData query having
// the same name. Then we will query the SharePoint site using the obtained REST/OData query to get a list
// of Councils and their respective topics in JSON format.
function GetCouncilsWithTopics(fn,globalVarURL) {
    GetODataCommand('GetCouncilsWithTopics', function(command) {
        GetJson(command).success(function(data) {
			fn(GetODataResult(data));
        });
    },globalVarURL);
}

// The name of this function is an exact replica of the name of a list item in the AppConfiguration list.
// Calling this function will result in querying the AppConfiguration list for the REST/OData query having
// the same name. Then we will query the SharePoint site using the obtained REST/OData query to get a list
// of Meeting Types in JSON format.
function GetMeetingTypes(fn,globalVarURL) {
    GetODataCommand('GetMeetingTypes', function(command) {
        GetJson(command).success(function(data) {
			fn(GetODataResult(data));
        });
    },globalVarURL);
}

// The name of this function is an exact replica of the name of a list item in the AppConfiguration list.
// Calling this function will result in querying the AppConfiguration list for the REST/OData query having
// the same name. Then we will query the SharePoint site using the obtained REST/OData query to get a list
// of Political Locations in JSON format.
function GetPoliticalLocations(fn,globalVarURL) {
    GetODataCommand('GetPoliticalLocations', function(command) {
        GetJson(command).success(function(data) {
             $('.loader').remove();
			fn(GetODataResult(data));
        });
    },globalVarURL);
}

// The name of this function is an exact replica of the name of a list item in the AppConfiguration list.
// Calling this function will result in querying the AppConfiguration list for the REST/OData query having
// the same name. Then we will query the SharePoint site using the obtained REST/OData query to get a list
// of Political Events in JSON format.
function GetPoliticalEvents(fn) {
    GetODataCommand('GetPoliticalEvents', function(command) {
        GetJson(command, _spPageContextInfo.webServerRelativeUrl).success(function(data) {
             $('.loader').remove();
			fn(GetODataResult(data));
        });
    });
}

// The name of this function is an exact replica of the name of a list item in the AppConfiguration list.
// Calling this function will result in querying the AppConfiguration list for the REST/OData query having
// the same name. Then we will query the SharePoint site using the obtained REST/OData query to get a list
// of Political Events in JSON format. This function is a derivative of a function with a similar name but
// is intended for use with the Mobile application.
function GetPoliticalEventsMobile(fn,globalVarURL) {
    GetODataCommand('GetPoliticalEventsMobile', function(command) {
        GetJson(command).success(function(data) {
             $('.loader').remove();
			fn(GetODataResult(data));
        });
    },globalVarURL);
}

// The name of this function is an exact replica of the name of a list item in the AppConfiguration list.
// Calling this function will result in querying the AppConfiguration list for the REST/OData query having
// the same name. Then we will query the SharePoint site using the obtained REST/OData query to get a list
// of Culture Locations in JSON format.
function GetCultureMeetingLocations(fn) {
	GetODataCommand('GetCultureMeetingLocations', function(command) {
        GetJson(command).success(function(data) {
             $('.loader').remove();
			fn(GetODataResult(data));
        });
    });
}

// The name of this function is an exact replica of the name of a list item in the AppConfiguration list.
// Calling this function will result in querying the AppConfiguration list for the REST/OData query having
// the same name. Then we will query the SharePoint site using the obtained REST/OData query to get a list
// of Cultural Areas in JSON format.
function GetCulturalAreas(fn) {
	GetODataCommand('GetCulturalAreas', function(command) {
        GetJson(command).success(function(data) {
             $('.loader').remove();
			fn(GetODataResult(data));
        });
    });
}

function GetCulturalEvents(fn) {
	GetODataCommand('GetCulturalEvents', function(command) {
        GetJson(command,  _spPageContextInfo.webServerRelativeUrl).success(function(data) {
             $('.loader').remove();
			fn(GetODataResult(data));
        });
    });
}

/* ****************************************** */